<script lang="ts">
  import { createEventDispatcher } from "svelte";
  const dispatch = createEventDispatcher();

  // public variable
  export let items: any[] = [];
  export let pageSelect: number = 1;
  export let maxItemPerPage: number = 10;
  export let pageItemsCurrent: any[];

  // เมื่อข้อมูล items เปลี่ยนแปลงให้ Set หน้าเป็นหน้า 1
  $: {
    if (maxItemPerPage || (items && items.length)) {
      pageSelect = 1;
    }
  }

  // pageQty จำนวนหน้าทั้งหมด
  $: pageQty = Math.ceil(items.length / +maxItemPerPage);

  let pages: any[] = [];
  $: {
    pages = [];
    for (let i = 1; i <= pageQty; i += 1) {
      if (Math.abs(i - pageSelect) < 3) {
        pages.push(i);
      }
    }
  }

  $: {
    const beginItemIndex = (pageSelect - 1) * +maxItemPerPage;
    pageItemsCurrent = items.slice(
      beginItemIndex,
      beginItemIndex + +maxItemPerPage
    );
    dispatch("pageSelect", pageItemsCurrent);
  }
</script>

{#if items.length}
  <div
    class="bg-white px-4 py-3 flex items-center justify-between border-t border-gray-200 sm:px-6"
  >
    <div class="w-full flex items-center justify-between">
      <div class="flex-2">
        <p class="text-sm leading-5 text-gray-700">
          <span class="font-medium">{pageSelect}</span>
          to
          <span class="font-medium">{pageQty}</span>
          of
          <span class="font-medium">{items.length}</span>
          items
        </p>
      </div>
      <div class="flex-1 flex justify-center">
        <nav class="relative inline-flex shadow-sm">
          <p
            on:click={() => {
              if (pageSelect != 1) {
                pageSelect = pageSelect - 1;
              }
            }}
            class="{pageSelect != 1 ? 'cursor-pointer text-red-500 hover:text-red-500': 'text-gray-400'} relative inline-flex items-center px-2 py-2 rounded-l-md border border-gray-300 bg-white text-sm leading-5 font-medium focus:z-10 focus:outline-none focus:border-blue-300 focus:shadow-outline-blue active:text-gray-500 transition ease-in-out duration-150"
            aria-label="Previous"
          >
            <svg class="h-5 w-5" viewBox="0 0 20 20" fill="currentColor">
              <path
                fill-rule="evenodd"
                d="M12.707 5.293a1 1 0 010 1.414L9.414 10l3.293 3.293a1 1 0 01-1.414 1.414l-4-4a1 1 0 010-1.414l4-4a1 1 0 011.414 0z"
                clip-rule="evenodd"
              />
            </svg>
          </p>
          {#each pages as pageNum}
            <p
              on:click={() => (pageSelect = pageNum)}
              class="{pageSelect == pageNum ? 'bg-red-500 text-white': ''} -ml-px cursor-pointer relative inline-flex items-center px-4 py-2 border border-gray-300 text-sm leading-5 font-medium hover:text-red-200 focus:z-10 focus:outline-none focus:border-blue-300 focus:shadow-outline-blue transition ease-in-out duration-150"
            >
              {pageNum}
            </p>
          {/each}
          <p
            on:click={() => {
              if (pageSelect != pageQty) {
                pageSelect = pageSelect + 1;
              }
            }}
            class="{pageSelect != pageQty ? 'cursor-pointer hover:text-red-500 text-red-500' : 'text-gray-400'} relative inline-flex items-center px-2 py-2 rounded-r-md border border-gray-300 bg-white text-sm leading-5 font-medium focus:z-10 focus:outline-none focus:border-blue-300 focus:shadow-outline-blue active:text-gray-500 transition ease-in-out duration-150"
            aria-label="Previous"
          >
            <svg class="h-5 w-5" viewBox="0 0 20 20" fill="currentColor">
              <path
                fill-rule="evenodd"
                d="M7.293 14.707a1 1 0 010-1.414L10.586 10 7.293 6.707a1 1 0 011.414-1.414l4 4a1 1 0 010 1.414l-4 4a1 1 0 01-1.414 0z"
                clip-rule="evenodd"
              />
            </svg>
          </p>
        </nav>
      </div>
      <div class="relative flex-2">
        <select
          bind:value={maxItemPerPage}
          class="block w-full py-2 px-8 pr-10 border border-gray-300 text-sm leading-5 font-medium rounded-md bg-white text-red-500 focus:outline-none focus:shadow-outline-blue focus:border-blue-300 transition ease-in-out duration-150"
          id="grid-state"
        >
          <option value={10}>10</option>
          <option value={20}>20</option>
          <option value={50}>50</option>
          <option value={100}>100</option>
          <option value={200}>200</option>
          <option value={500}>500</option>
          <option value={1000}>1000</option>
        </select>
      </div>
    </div>
  </div>
{/if}
